<template>
  <q-form @submit.prevent="onSubmit">
    <city-component v-model="updateForm.fullAddress" class="q-mb-md" />
    <div class="q-gutter-sm q-mb-md">
      <q-radio v-model="infoType" val="nationalId" label="CMND" />
      <q-radio v-model="infoType" val="passport" label="Hộ chiếu" />
      <q-radio v-model="infoType" val="other" label="Thông tin khác" />
    </div>
    <div class="q-mb-md">
      <q-input
        v-if="infoType === 'nationalId'"
        v-model="updateForm.nationalId"
        outlined
        label="CMND *"
        mask="### ### ### ###"
        unmasked-value
      />
      <q-input
        v-else-if="infoType === 'passport'"
        v-model="updateForm.passport"
        outlined
        label="Hộ chiếu"
      />
      <q-input v-else v-model="updateForm.otherInformation" outlined label="Thông tin khác" />
    </div>
    <div class="row q-col-gutter-sm q-mb-md">
      <div class="col-12 col-md-6">
        <q-input v-model="updateForm.companyAddress" outlined label="Địa chỉ công ty (nếu có)" />
      </div>
      <div class="col-12 col-md-6">
        <q-input
          v-model="updateForm.companyPhone"
          outlined
          label="Điện thoại công ty (nếu có)"
          mask="(###) ### - ####"
          unmasked-value
        />
      </div>
    </div>
    <q-input v-model="updateForm.bankOwner" outlined label="Tên chủ tài khoản" class="q-mb-md" />
    <q-input v-model="updateForm.bankNumber" outlined label="Số tài khoản" class="q-mb-md" />
    <q-input v-model="updateForm.bankBranch" outlined label="Chi nhánh" class="q-mb-md" />

    <div class="q-mt-md">
      <q-btn label="Lưu" type="submit" color="primary" />
    </div>
  </q-form>
</template>

<script>
import { mapState, mapActions } from 'vuex';
import CityComponent from '~/components/commons/City.vue';

export default {
  components: { CityComponent },
  data() {
    return {
      infoType: '',
      updateForm: {
        fullAddress: {
          city: '',
          district: '',
          ward: '',
          address: ''
        },
        nationalId: '',
        passport: '',
        otherInformation: '',
        companyAddress: '',
        companyPhone: '',
        bankOwner: '',
        bankNumber: '',
        bankBranch: ''
      }
    };
  },
  computed: {
    ...mapState({
      authUser: state => state.auth.user
    })
  },
  watch: {
    authUser: {
      handler() {
        this.updateForm = {
          fullAddress: {
            city: this.authUser.city,
            district: this.authUser.district,
            ward: this.authUser.ward,
            address: this.authUser.address
          },
          nationalId: this.authUser.nationalId,
          passport: this.authUser.passport,
          otherInformation: this.authUser.otherInformation,
          companyAddress: this.authUser.companyAddress,
          companyPhone: this.authUser.companyPhone,
          bankOwner: this.authUser.bankOwner,
          bankNumber: this.authUser.bankNumber,
          bankBranch: this.authUser.bankBranch
        };

        if (this.updateForm.nationalId) {
          this.infoType = 'nationalId';
        } else if (this.updateForm.passport) {
          this.infoType = 'passport';
        } else {
          this.infoType = 'otherInformation';
        }
      },
      immediate: true
    },
    infoType: {
      handler() {
        this.updateForm.nationalId = '';
        this.updateForm.passport = '';
        this.updateForm.otherInformation = '';
      }
    }
  },
  methods: {
    ...mapActions({
      updateMyInfo: 'auth/updateMyInfo'
    }),
    onSubmit() {
      const { fullAddress, ...data } = this.updateForm;
      const form = { ...fullAddress, ...data };
      this.updateMyInfo(form);
    }
  }
};
</script>
